/*
  @author: asukaze
  @url: http://www.asukaze.net/
  @title: Rotate Documents
  @description: Rotate HTML Documents.
  @version: 0.3.0
  @license: MPL 1.1/GPL 2.0/LGPL 2.1
*/

function getRotateElement(doc){
  var rotate = doc.getElementById("__rotate_body");
  if(rotate){
    return rotate;
  }
  var body = doc.getElementsByTagName("body")[0];
  var div = doc.createElement("div");
  div.setAttribute("id", "__rotate_body");
  while(body.hasChildNodes()){
    div.appendChild(body.childNodes[0]);
  }
  body.appendChild(div);
  return div;
}

exports.rotate = function(win, angle){
  var doc = win.content.document;
  var scrollY = win.scrollY;
  var margin = 17; // scroll bar width
  var div = getRotateElement(doc);
  if(angle == -90 || angle == 90){
    var width = win.innerHeight - margin;
    var height = win.innerWidth - margin;
    var left;
    var top;
    if(angle == -90){
      left = (win.innerWidth - width) / 2;
      top = 1000 - win.innerWidth + left;
    }else{
      top = (win.innerHeight - height) / 2;
      left = 10000 - win.innerWidth - top;
    }
    div.setAttribute("style",
      "-moz-transform: rotate(" + angle + "deg);"
      + "position: absolute;"
      + "width: " + width + "px;"
      + "height: " + height + "px;"
      + "left: " + left + "px;"
      + "top: " + top + "px;"
    );
    if(angle == -90){
      win.scrollTo(scrollY, 1000 - width);
    }else{
      win.scrollTo(10000 - scrollY - height, 0);
    }
  }else if(angle == 180){
    div.setAttribute("style", "-moz-transform: rotate(180deg);");
  }else{
    div.removeAttribute("style");
  }
}
